SystemOrganization addCategory: #'Alien-CoreTest'!

TestCase subclass: #AlienSunit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-CoreTest'!

!AlienSunit class methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 12:35'!
testParser
	"Just confirm it will parse"
	
	(Parser new parse: (MethodNode sourceCodeAt: #primitiveErrorVariableName) class: Parser) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: ''foo''> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) generate.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 21:57'!
testAccessing
	| alien |
	alien := Alien newCString: 'foo'.
	alien freeAfter: [:cstring | 
			self should: [cstring dataSize = 4].
			self should: [cstring strcpy = 'foo']].
	self should: [alien address = 0].
	self should: [alien dataSize = 0].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 14:07'!
testAccessorsFailure
	| alien |
	alien := Alien newC: 1. 
	self should: [alien signedByteAt: 2 put: 16r80] raise: Error.
	self should: [alien signedShortAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedByteAt: 2 put: 16r80] raise: Error.
	self should: [alien unsignedShortAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien floatAt: 1 put: 1.0] raise: Error.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	self should: [alien signedByteAt: 2 ] raise: Error.
	self should: [alien signedShortAt: 1 ] raise: Error.
	self should: [alien signedLongAt: 1] raise: Error.
	self should: [alien signedLongLongAt: 1] raise: Error.
	self should: [alien unsignedByteAt: 2] raise: Error.
	self should: [alien unsignedShortAt: 1] raise: Error.
	self should: [alien unsignedLongAt: 1] raise: Error.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	self should: [alien floatAt: 1 ] raise: Error.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 2. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	self should: [alien signedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongLongAt: 1 put: 16r80] raise: Error.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [alien unsignedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien floatAt: 1 put: 1.0] raise: Error.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	self should: [alien signedLongAt: 1] raise: Error.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	self should: [alien unsignedLongAt: 1] raise: Error.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	self should: [alien floatAt: 1 ] raise: Error.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 3. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	self should: [alien signedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongLongAt: 1 put: 16r80] raise: Error.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [alien unsignedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien floatAt: 1 put: 1.0] raise: Error.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	self should: [alien signedLongAt: 1] raise: Error.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	self should: [alien unsignedLongAt: 1] raise: Error.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	self should: [alien floatAt: 1 ] raise: Error.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 4. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	alien signedLongAt: 1 put: 16r80.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	alien unsignedLongAt: 1 put: 16r80.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	alien floatAt: 1 put: 1.0.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	alien signedLongAt: 1.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	alien unsignedLongAt: 1.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	alien floatAt: 1.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 8. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	alien signedLongAt: 1 put: 16r80.
	alien signedLongLongAt: 1.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	alien unsignedLongAt: 1 put: 16r80.
	alien unsignedLongLongAt: 1 put: 16r80.
	alien floatAt: 1 put: 1.0.
	alien doubleAt: 1 put: 1.0.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	alien signedLongAt: 1.
	alien signedLongLongAt: 1.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	alien unsignedLongAt: 1.
	alien unsignedLongLongAt: 1.
	alien floatAt: 1.
	alien doubleAt: 1.
	alien free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:43'!
testAtAddress
	| alien address alias |
	alien := Alien newCString: 'foo'.
	address := alien address.
	"This means alias and alien both point to the same address"
	alias := Alien atAddress: address dataSize: 4.
	self should: [alias dataSize = 4].
	self should: [alias strcpy = 'foo'].
	alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:08'!
testByte
	| byte |
	byte := Alien newC:1.
	0 to: 255 do: 
		[:i  | byte unsignedByteAt: 1 put: i.
		self should: [(byte unsignedByteAt: 1) = i]].
	-128 to: 127 do: 
		[:j |  byte signedByteAt: 1 put: j.
		self should: [(byte signedByteAt: 1) = j]].
	-255 to: -129 do: 
		[:k |  self should: [byte signedByteAt: 1 put: k] raise: Error].
	128 to: 255 do: 
		[:k |  self should: [byte signedByteAt: 1 put: k] raise: Error].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testByteAccessors
	| alien |
	alien := Alien newC: 2. 
	alien signedByteAt: 1 put: 16r7F.
	self should: [(alien signedByteAt: 1) = 16r7F].
	self should: [(alien asSignedByte) = 16r7F].
	self should: [alien signedByteAt: 1 put: 16r80] raise: Error.
	alien signedByteAt: 2 put: 16r00.
	alien signedByteAt: 1 put: 16r7F.
	self should: [(alien signedByteAt: 2) = 16r00].
	alien signedByteAt: 1 put: -1*16r80.
	self should: [(alien signedByteAt: 1) =  (-1*16r80)].
	self should: [alien signedByteAt: 1 put: -1*16r81] raise: Error.
	alien unsignedByteAt: 1 put: 16r7F.
	self should: [(alien signedByteAt: 1) = 16r7F].
	alien unsignedByteAt: 1 put: 16r80.
	self should: [(alien asSignedByte) = -128].
	self should: [(alien signedByteAt: 1) = -128].
	alien unsignedByteAt: 1 put: 16r81.
	self should: [(alien signedByteAt: 1) = -127].
	alien unsignedByteAt: 1 put: 16r7F.
	self should: [(alien unsignedByteAt: 1) = 16r7F].
	alien unsignedByteAt: 1 put: 16r80.
	self should: [(alien unsignedByteAt: 1) = 16r80].
	alien unsignedByteAt: 1 put: 16r81.
	self should: [(alien unsignedByteAt: 1) = 16r81].
	alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testDoubleAccessors
	| alien |
	alien := Alien newC: 8. 
	alien doubleAt: 1 put: 8.8.
	self should: [(alien doubleAt: 1) = 8.8].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testFloatAccessors
	| alien |
	alien := Alien newC: 4. 
	alien floatAt: 1 put: 8.8.
	self should: [(alien floatAt: 1) closeTo: 8.8].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 14:09'!
testLibCExamples
	| sortedData unsorted sorted |
	
	3 foo.
	sortedData := Alien exampleCqsort.
	unsorted := sortedData key copy.
	sorted := unsorted asSortedCollection.
	self should: [sortedData value = sorted asArray].
	Alien examplePrintf.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:09'!
testLong
	| long unsignedIntegerIntervalue k signedIntegerIntervalue |
	
	long := Alien newC: 4.
	#( 0 4294967295) do: 
		[:i  | long unsignedLongAt: 1 put: i.
		self should: [(long unsignedLongAt: 1) = i]].
	#( -2147483648 2147483647) do: 
		[:j |  long signedLongAt: 1 put: j.
		self should: [(long signedLongAt: 1) = j]].
	unsignedIntegerIntervalue := (0 to: 4294967295).
	10000 timesRepeat: [
			k := unsignedIntegerIntervalue atRandom.
			long unsignedLongAt: 1 put: k.
			self should: [(long unsignedLongAt: 1) = k]].
	signedIntegerIntervalue := (-2147483648 to: 2147483647).
	10000 timesRepeat: [
			k := signedIntegerIntervalue atRandom.
			long signedLongAt: 1 put: k.
			self should: [(long signedLongAt: 1) = k]].
	
	signedIntegerIntervalue := (-4294967295 to: -2147483649).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [long signedLongAt: 1 put: k] raise: Error].
	
	signedIntegerIntervalue := (2147483648 to: 4294967295).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [long signedLongAt: 1 put: k] raise: Error].
	! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testLongAccessors
	| alien |
	Smalltalk wordSize = 4 ifFalse: [^self].
	
	alien := Alien newC: 4. 
	alien signedLongAt: 1 put: 16r7FFFFFFF.
	self should: [(alien signedLongAt: 1) = 16r7FFFFFFF].
	self should: [(alien asSignedLong) = 16r7FFFFFFF].
	self should: [alien signedLongAt: 1 put: 16r80000000] raise: Error.
	alien signedLongAt: 1 put: -1*16r80000000.
	self should: [(alien signedLongAt: 1) =  (-1*16r80000000)].
	self should: [alien signedLongAt: 1 put: -1*16r80000001] raise: Error.
	alien unsignedLongAt: 1 put: 16r7FFFFFFF.
	self should: [(alien signedLongAt: 1) = 16r7FFFFFFF].
	alien unsignedLongAt: 1 put: 16r80000000.
	self should: [(alien signedLongAt: 1) = -2147483648].
	alien unsignedLongAt: 1 put: 16r80000001.
	self should: [(alien signedLongAt: 1) = -2147483647].
	alien unsignedLongAt: 1 put: 16r7FFFFFFF.
	self should: [(alien unsignedLongAt: 1) = 16r7FFFFFFF]. 
	self should: [(alien asUnsignedLong) = 16r7FFFFFFF]. 
	alien unsignedLongAt: 1 put: 16r80000000.
	self should: [(alien unsignedLongAt: 1) = 16r80000000].
	alien unsignedLongAt: 1 put: 16r80000001.
	self should: [(alien unsignedLongAt: 1) = 16r80000001].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:09'!
testLongLong
	| unsignedIntegerIntervalue k signedIntegerIntervalue longlong |

	longlong := Alien newC: 8.
	#( 0 4294967295 18446744073709551615) do: 
		[:i  | longlong unsignedLongLongAt: 1 put: i.
		self should: [(longlong unsignedLongLongAt: 1) = i]].
	#(-9223372036854775808  -2147483648 2147483647 9223372036854775807) do: 
		[:j |  longlong signedLongLongAt: 1 put: j.
		self should: [(longlong signedLongLongAt: 1) = j]].
	unsignedIntegerIntervalue := (0 to: 18446744073709551615).
	10000 timesRepeat: [
			k := unsignedIntegerIntervalue atRandom.
			longlong unsignedLongLongAt: 1 put: k.
			self should: [(longlong unsignedLongLongAt: 1) = k]].
	signedIntegerIntervalue := (-9223372036854775808 to: 9223372036854775807).
	10000 timesRepeat: [
			k := signedIntegerIntervalue atRandom.
			longlong signedLongLongAt: 1 put: k.
			self should: [(longlong signedLongLongAt: 1) = k]].
	
	signedIntegerIntervalue := (-18446744073709551615 to: -9223372036854775809).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [longlong signedLongLongAt: 1 put: k] raise: Error].
	
	signedIntegerIntervalue := (9223372036854775808 to: 18446744073709551615).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [longlong signedLongLongAt: 1 put: k] raise: Error].
	! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 14:20'!
testParser
	"Just confirm it will parse"
	
	(Parser new parse: (MethodNode sourceCodeAt: #primitiveErrorVariableName) class: Parser) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: ''foo''> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) generate.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 22:00'!
testPointer
	| alien address alias |
	alien := Alien newC: 3.
	address := alien address.
	alias := Alien forPointer: address.
	self should: [alias dataSize = 0].
	self should: [alias address = address].
	alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:09'!
testShort
	| short |
	short := Alien new: 2.
	0 to: 65535 do: 
		[:i  | short unsignedShortAt: 1 put: i.
		self should: [(short unsignedShortAt: 1) = i]].
	-32768 to: 32767 do: 
		[:j |  short signedShortAt: 1 put: j.
		self should: [(short signedShortAt: 1) = j]].
	-65535 to: -32769 do: 
		[:k |  self should: [short signedShortAt: 1 put: k] raise: Error].
	32768 to: 65535 do: 
		[:k |  self should: [short signedShortAt: 1 put: k] raise: Error].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testShortAccessors
	| alien |
	alien := Alien newC: 2. 
	alien signedShortAt: 1 put: 16r7FFF.
	self should: [(alien signedShortAt: 1) = 16r7FFF].
	self should: [(alien asSignedShort) = 16r7FFF].
	self should: [alien signedShortAt: 1 put: 16r8000] raise: Error.
	alien signedShortAt: 1 put: -1*16r8000.
	self should: [(alien signedShortAt: 1) =  (-1*16r8000)].
	self should: [alien signedShortAt: 1 put: -1*16r8001] raise: Error.
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [(alien signedShortAt: 1) = 16r7FFF].
	alien unsignedShortAt: 1 put: 16r8000.
	self should: [(alien signedShortAt: 1) = -32768].
	alien unsignedShortAt: 1 put: 16r8001.
	self should: [(alien signedShortAt: 1) = -32767].
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [(alien unsignedShortAt: 1) = 16r7FFF].
	self should: [(alien asUnsignedShort) = 16r7FFF].
	alien unsignedShortAt: 1 put: 16r8000.
	self should: [(alien unsignedShortAt: 1) = 16r8000].
	alien unsignedShortAt: 1 put: 16r8001.
	self should: [(alien unsignedShortAt: 1) = 16r8001].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 22:00'!
testasAlien
	| alien alienValue |
	alien := Alien newCString: 'foo'.
	self should: [alien == alien asAlien].
	alien free.
	alienValue := false asAlien.
	self should: [alienValue isNumber and: [alienValue == 0]].
	alienValue := true asAlien.
	self should: [alienValue isNumber and: [alienValue == 1]].
	alienValue := nil asAlien.
	self should: [alienValue isNumber and: [alienValue == 0]].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 15:18'!
testnewC

	| alien |
	alien := 'foo' asAlien.
	self should: [alien strcpy = 'foo'].
	alien free. ! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 15:17'!
testnewGC
	1 foo.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:43'!
teststrcpy

	| alien |
	alien := 'foo' asAlien.
	self should: [alien strcpy = 'foo'].
	self should: [(alien strcpyFrom: 2) = 'oo'].
	alien free.
	alien := 'foo' asAlien.
	self should: [alien strcpyUTF8 = 'foo'].
	self should: [(alien strcpyUTF8From: 2) = 'oo'].
	alien free.
! !
